/***************************************************************************
 *                       FileDialog.h  -  description
 *                               -------------------
 *  begin                : Tue Sep 10 10:40:21 BST 2002
 *  copyright            : (C) 2002 by Dmitri Skachkov
 *  email                : d_skachkov@yahoo.com
 ***************************************************************************/

/***************************************************************************
 *                                                                         *
 *   This program is free software; you can redistribute it and/or modify  *
 *   it under the terms of the GNU General Public License as published by  *
 *   the Free Software Foundation; either version 2 of the License, or     *
 *   (at your option) any later version.                                   *
 *                                                                         *
 ***************************************************************************/
#include <qmainwindow.h>
#include <qmenubar.h>
#ifndef __FOR_QT__
#include <qpe/menubutton.h>
#endif
#include <qpopupmenu.h>
#include <qtextstream.h>
#include <qaction.h>
#include <qpainter.h>
#include <qframe.h>
#include <qpixmap.h>
#include <qfont.h>
#include <qfile.h>
#include <qstring.h>
#include <qvbox.h>
#include <qlineedit.h>
#include <qlistview.h>
#include <qcheckbox.h>
#include <qspinbox.h>
#include <qcombobox.h>
#include <qpushbutton.h>
#include <qcheckbox.h>

class QAction;
class QActionGroup;
class QPopupMenu;
class QPainter;
class QPixmap;
class SettingsDlg;
class MyView;

class GetFileName : public QWidget
{
    Q_OBJECT
    public:
	GetFileName(QWidget *parent=0, const char *name=0); 
	QString filename,folderpath;
	bool showHidden;
	QString fontName;
    public slots:
	void setFolderList(QString folder);
    private slots:
	void resizeEvent(QResizeEvent *);
	void showEvent(QShowEvent *);
	void slotFolderSelected( QListViewItem * );
	void keyPressEvent(QKeyEvent * e);
	void cdTo();
	void toggleHidden();
    private:
	QVBox *boxAll;
	QLineEdit *filepath;
	QListView *listview;
	QString currentPath;
	QPushButton *cdButton;
	QCheckBox *hiddenCheckBox;
    signals:
	void fileSelectedSignal();
	void fileNotSelectedSignal();
};


