/***************************************************************************
 *                       IntDict.h  -  description
 *                               -------------------
 *  begin                : Tue March 1 10:40:21 BST 2003
 *  copyright            : (C) 2002 by Dmitri Skachkov
 *  email                : d_skachkov@yahoo.com
 ***************************************************************************/

/***************************************************************************
 *                                                                         *
 *   This program is free software; you can redistribute it and/or modify  *
 *   it under the terms of the GNU General Public License as published by  *
 *   the Free Software Foundation; either version 2 of the License, or     *
 *   (at your option) any later version.                                   *
 *                                                                         *
 ***************************************************************************/
#ifndef INTDICT_H
#define INTDICT_H



#include <qstring.h>
#include <qwidget.h>
#include <qregexp.h>
#include "dictionary_impl.h"

class IntDict;
class QWidget;
class QVBoxLayout;
class QHBoxLayout;
class QListBox;
class QLineEdit;
class QPushButton;
class TextReader;
class WordEdit;

class IntDict:public QWidget
{
	Q_OBJECT
	signals:
		void translate(const QString &);
		void hideDict();
	public slots:
		void okPressed();
		void cancelPressed();
		void setWordToTranslate(const QString &str);
		void showKeyboard();
		void hideKeyboard();

	private:
	QString dictName;
	Dictionary *dict;
	QString word,translatedWord,meaning,error,info,sense,headWord,partOfSpeech,pron;
	int ndef;
	bool ret,subword;
	QString dictFormat(const QString&, const QString&);
	int dictProcessBody(const QString&, int, QString&, QString&);
	TextReader * parent;
	public:
	IntDict(TextReader *m=0, QWidget *w=0, const char *name=0);
	~IntDict();
	QString getDictName();
	int exactTrans;
	void setDictName(QString);
	void findWord(QString);
	void nextWord();
	void prevWord();
	void updateLook();
	QString getWord();
	QString getSense();
	QString getError();
	QString getInfo();
	WordEdit * wordField;
	QListBox * wordList;
	QHBoxLayout * fieldLayout;
	QVBoxLayout * dictLayout;
	QPushButton * okButton;
	QPushButton * cancelButton;

	/*	public slots:
		void	hideDict();

	 */	

};
#endif
