/***************************************************************************
 *                       Stream.cpp  -  description
 *                               -------------------
 *  begin                : Tue March 1 10:40:21 BST 2003
 *  copyright            : (C) 2002 by Dmitri Skachkov
 *  email                : d_skachkov@yahoo.com
 ***************************************************************************/

/***************************************************************************
 *                                                                         *
 *   This program is free software; you can redistribute it and/or modify  *
 *   it under the terms of the GNU General Public License as published by  *
 *   the Free Software Foundation; either version 2 of the License, or     *
 *   (at your option) any later version.                                   *
 *                                                                         *
 ***************************************************************************/


#include "Stream.h"
#include "BasicStream.h"

Stream::Stream():BasicStream()
{
	pdbToIndex=0;
    fileOpened = false;
}

Stream::~Stream()
{	
	closeFile();
	printf("Stream closed");
}


void Stream::setEncoding(QString e)
{
    if (e.length() == 0) e = "ISO 8859-1";
    recode = false;
    encoding = e;
    if (!textstream) return;
    textstream->~QTextStream();
    textstream = new QTextStream(&file);
    if (encoding == "UTF-8")
    {
    	textstream->setEncoding(QTextStream::UnicodeUTF8);
	return;
    }
    decoder->setCodec(e);
    recode = true;
    if (decoder->Index > -1) return;
    recode = false;
    if (encoding == "ISO 8859-1")
    {
	textstream->setEncoding(QTextStream::Latin1);
	return;
    }
    textstream->setCodec(QTextCodec::codecForName(encoding));
}


int Stream::getPosition()
{
    return file.at();
}

void Stream::setPosition(int pos)
{
    file.at(pos);
}

int Stream::getSize()
{
    return file.size();
}

void Stream::rewind()
{
    file.at(0);
}

void Stream::gotoEnd()
{
    file.at(file.size());
}

bool Stream::openFile(const QString & filepath)
{
    QFile f;
    if ( !QFile::exists( filepath ) ) return false;
    f.setName( filepath ); 
    if (!f.open( IO_ReadOnly ))
    {
	return false;
    }
    fileOpened = true;
    f.close();
    if (file.isOpen()) file.close();
    file.setName( filepath ); 
    file.open( IO_ReadOnly );
    docSize = file.size();
    numberOfPages = int(docSize/2000) + 1;
    newParagraph = false;
    newLine = false;
    if (textstream) textstream->~QTextStream();
    textstream = new QTextStream(&file);
    resetTags();
    setEncoding(encoding);
    if (links) delete [] links;
    links = 0;
    linksFound = false;
    return true;
}

void Stream::closeFile()
{
    if (textstream) textstream->~QTextStream();
    textstream = 0;
    file.close();
}

bool Stream::atEnd()
{
    return file.atEnd();
}

QString Stream::getFileDir()
{
    QFileInfo fi(file);
    return fi.dirPath(true);
}

bool Stream::isReady()
{
	if (fileOpened) 
	{
		return true;
	}else
	{
		return false;
	}
}

bool Stream::isFileStream()
{
	return true;
}

